This is an automated email from the ASF dual-hosted git repository.

vatamane pushed a commit to branch 3.5.1
in repository https://gitbox.apache.org/repos/asf/couchdb-docker.git

commit c3f11ad0561587bb18f2f20072444704acaa71b9
Author: Nick Vatamaniuc <[email protected]>
AuthorDate: Tue Nov 11 14:52:41 2025 -0500

    CouchDB 3.5.1
---
 3.5.1-nouveau/Dockerfile    |  88 ++++++++++++++++++++++++++++++++
 3.5.1-nouveau/nouveau.yaml  |  27 ++++++++++
 3.5.1/10-docker-default.ini |   8 +++
 3.5.1/Dockerfile            | 104 +++++++++++++++++++++++++++++++++++++
 3.5.1/docker-entrypoint.sh  | 122 ++++++++++++++++++++++++++++++++++++++++++++
 3.5.1/vm.args               |  47 +++++++++++++++++
 README.md                   |   1 +
 7 files changed, 397 insertions(+)

diff --git a/3.5.1-nouveau/Dockerfile b/3.5.1-nouveau/Dockerfile
new file mode 100644
index 0000000..060ec69
--- /dev/null
+++ b/3.5.1-nouveau/Dockerfile
@@ -0,0 +1,88 @@
+# Licensed under the Apache License, Version 2.0 (the "License"); you may not
+# use this file except in compliance with the License. You may obtain a copy of
+# the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+# License for the specific language governing permissions and limitations under
+# the License.
+
+FROM debian:bookworm-slim
+
+LABEL maintainer="CouchDB Developers [email protected]"
+
+# Add CouchDB user account to make sure the IDs are assigned consistently
+RUN groupadd -g 5984 -r nouveau && useradd -u 5984 -d /opt/nouveau -g nouveau 
nouveau
+
+# be sure GPG and apt-transport-https are available and functional
+RUN set -ex; \
+    apt-get update; \
+    apt-get install -y --no-install-recommends \
+        apt-transport-https \
+        ca-certificates \
+        dirmngr \
+        gnupg \
+     ; \
+    rm -rf /var/lib/apt/lists/*
+
+# Nouveau wants a JRE/JDK
+RUN set -ex; \
+    apt-get update; \
+    apt-get install -y --no-install-recommends \
+        openjdk-17-jre-headless \
+     ; \
+    rm -rf /var/lib/apt/lists/*
+
+# grab tini for signal handling and zombie reaping
+# see https://github.com/apache/couchdb-docker/pull/28#discussion_r141112407
+RUN set -eux; \
+    apt-get update; \
+    apt-get install -y --no-install-recommends tini; \
+    rm -rf /var/lib/apt/lists/*; \
+    tini --version
+
+# 
http://docs.couchdb.org/en/latest/install/unix.html#installing-the-apache-couchdb-packages
+# gpg: rsa8192 205-01-19 The Apache Software Foundation (Package repository 
signing key) <[email protected]>
+
+ENV GPG_COUCH_KEY 390EF70BB1EA12B2773962950EE62FB37A00258D
+
+RUN set -eux; \
+   apt-get update; \
+   apt-get install -y curl; \
+   export GNUPGHOME="$(mktemp -d)"; \
+   curl -fL -o keys.asc https://couchdb.apache.org/repo/keys.asc; \
+   gpg --batch --import keys.asc; \
+   gpg --batch --export "${GPG_COUCH_KEY}" > 
/usr/share/keyrings/couchdb-archive-keyring.gpg; \
+   command -v gpgconf && gpgconf --kill all || :; \
+   rm -rf "$GNUPGHOME"; \
+   apt-key list; \
+   apt purge -y --autoremove curl; \
+   rm -rf /var/lib/apt/lists/*
+
+RUN . /etc/os-release; \
+   echo "deb [signed-by=/usr/share/keyrings/couchdb-archive-keyring.gpg] 
https://apache.jfrog.io/artifactory/couchdb-deb/ bookworm main" | \
+       tee /etc/apt/sources.list.d/couchdb.list >/dev/null
+
+# https://github.com/apache/couchdb-pkg/blob/master/debian/README.Debian
+RUN set -eux; \
+    apt-get update; \
+    \
+    echo "couchdb-nouveau couchdb-nouveau/enable select false" | 
debconf-set-selections; \
+    DEBIAN_FRONTEND=noninteractive COUCHDB_NOUVEAU_ENABLE=1 apt-get install -y 
--allow-downgrades --allow-remove-essential --allow-change-held-packages 
--no-install-recommends \
+            couchdb-nouveau=3.5.1~bookworm; \
+    rm -rf /var/lib/apt/lists/*; \
+    chown -R nouveau:nouveau /opt/nouveau
+
+COPY --chown=nouveau:nouveau nouveau.yaml /opt/nouveau/etc/nouveau.yaml
+
+VOLUME /opt/nouveau/data
+
+# 5987: Nouveau App
+# 5988: Nouveau Admin
+EXPOSE 5987 5988
+
+# TODO: re-add tini
+CMD ["/usr/bin/java", "-server", "-Djava.awt.headless=true", "-Xmx2g", "-jar", 
"/opt/nouveau/lib/nouveau-1.0-SNAPSHOT.jar", "server", 
"/opt/nouveau/etc/nouveau.yaml"]
diff --git a/3.5.1-nouveau/nouveau.yaml b/3.5.1-nouveau/nouveau.yaml
new file mode 100644
index 0000000..5750942
--- /dev/null
+++ b/3.5.1-nouveau/nouveau.yaml
@@ -0,0 +1,27 @@
+maxIndexesOpen: 3000
+commitIntervalSeconds: 30
+idleSeconds: 60
+rootDir: ./data/nouveau
+
+logging:
+  level: INFO
+
+server:
+  applicationConnectors:
+    - type: http
+      bindHost: 0.0.0.0
+      port: 5987
+      useDateHeader: false
+  adminConnectors:
+    - type: http
+      bindHost: 0.0.0.0
+      port: 5988
+      useDateHeader: false
+  gzip:
+    includedMethods:
+      - GET
+      - POST
+  requestLog:
+    appenders:
+      - type: console
+        target: stderr
diff --git a/3.5.1/10-docker-default.ini b/3.5.1/10-docker-default.ini
new file mode 100644
index 0000000..1aa633c
--- /dev/null
+++ b/3.5.1/10-docker-default.ini
@@ -0,0 +1,8 @@
+; CouchDB Configuration Settings
+
+; Custom settings should be made in this file. They will override settings
+; in default.ini, but unlike changes made to default.ini, this file won't be
+; overwritten on server upgrade.
+
+[chttpd]
+bind_address = any
diff --git a/3.5.1/Dockerfile b/3.5.1/Dockerfile
new file mode 100644
index 0000000..a0ac65e
--- /dev/null
+++ b/3.5.1/Dockerfile
@@ -0,0 +1,104 @@
+# Licensed under the Apache License, Version 2.0 (the "License"); you may not
+# use this file except in compliance with the License. You may obtain a copy of
+# the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+# License for the specific language governing permissions and limitations under
+# the License.
+
+FROM debian:bookworm-slim
+
+LABEL maintainer="CouchDB Developers [email protected]"
+
+# Add CouchDB user account to make sure the IDs are assigned consistently
+RUN groupadd -g 5984 -r couchdb && useradd -u 5984 -d /opt/couchdb -g couchdb 
couchdb
+
+# be sure GPG and apt-transport-https are available and functional
+RUN set -ex; \
+    apt-get update; \
+    apt-get install -y --no-install-recommends \
+        apt-transport-https \
+        ca-certificates \
+        dirmngr \
+        gnupg \
+     ; \
+    rm -rf /var/lib/apt/lists/*
+
+# grab tini for signal handling and zombie reaping
+# see https://github.com/apache/couchdb-docker/pull/28#discussion_r141112407
+RUN set -eux; \
+    apt-get update; \
+    apt-get install -y --no-install-recommends tini; \
+    rm -rf /var/lib/apt/lists/*; \
+    tini --version
+
+# 
http://docs.couchdb.org/en/latest/install/unix.html#installing-the-apache-couchdb-packages
+ENV GPG_COUCH_KEY \
+# gpg: rsa8192 205-01-19 The Apache Software Foundation (Package repository 
signing key) <[email protected]>
+    390EF70BB1EA12B2773962950EE62FB37A00258D
+RUN set -eux; \
+    apt-get update; \
+    apt-get install -y curl; \
+    export GNUPGHOME="$(mktemp -d)"; \
+    curl -fL -o keys.asc https://couchdb.apache.org/repo/keys.asc; \
+    gpg --batch --import keys.asc; \
+    gpg --batch --export "${GPG_COUCH_KEY}" > 
/usr/share/keyrings/couchdb-archive-keyring.gpg; \
+    command -v gpgconf && gpgconf --kill all || :; \
+    rm -rf "$GNUPGHOME"; \
+    apt-key list; \
+    apt purge -y --autoremove curl; \
+    rm -rf /var/lib/apt/lists/*
+
+ENV COUCHDB_VERSION 3.5.1
+
+RUN . /etc/os-release; \
+    echo "deb [signed-by=/usr/share/keyrings/couchdb-archive-keyring.gpg] 
https://apache.jfrog.io/artifactory/couchdb-deb/ ${VERSION_CODENAME} main" | \
+        tee /etc/apt/sources.list.d/couchdb.list >/dev/null
+
+# https://github.com/apache/couchdb-pkg/blob/master/debian/README.Debian
+RUN set -eux; \
+    apt-get update; \
+    \
+    echo "couchdb couchdb/mode select none" | debconf-set-selections; \
+# we DO want recommends this time
+    DEBIAN_FRONTEND=noninteractive apt-get install -y --allow-downgrades 
--allow-remove-essential --allow-change-held-packages \
+            couchdb="$COUCHDB_VERSION"~bookworm \
+    ; \
+# Undo symlinks to /var/log and /var/lib
+    rmdir /var/lib/couchdb /var/log/couchdb; \
+    rm /opt/couchdb/data /opt/couchdb/var/log; \
+    mkdir -p /opt/couchdb/data /opt/couchdb/var/log; \
+    chown couchdb:couchdb /opt/couchdb/data /opt/couchdb/var/log; \
+    chmod 777 /opt/couchdb/data /opt/couchdb/var/log; \
+# Remove file that sets logging to a file
+    rm /opt/couchdb/etc/default.d/10-filelog.ini; \
+# Check we own everything in /opt/couchdb. Matches the command in 
dockerfile_entrypoint.sh
+    find /opt/couchdb \! \( -user couchdb -group couchdb \) -exec chown -f 
couchdb:couchdb '{}' +; \
+# Setup directories and permissions for config. Technically these could be 555 
and 444 respectively
+# but we keep them as 755 and 644 for consistency with CouchDB defaults and 
the dockerfile_entrypoint.sh.
+    find /opt/couchdb/etc -type d ! -perm 0755 -exec chmod -f 0755 '{}' +; \
+    find /opt/couchdb/etc -type f ! -perm 0644 -exec chmod -f 0644 '{}' +; \
+# only local.d needs to be writable for the docker_entrypoint.sh
+    chmod -f 0777 /opt/couchdb/etc/local.d; \
+# apt clean-up
+    rm -rf /var/lib/apt/lists/*;
+
+# Add configuration
+COPY --chown=couchdb:couchdb 10-docker-default.ini /opt/couchdb/etc/default.d/
+COPY --chown=couchdb:couchdb vm.args /opt/couchdb/etc/
+
+COPY docker-entrypoint.sh /usr/local/bin
+RUN ln -s usr/local/bin/docker-entrypoint.sh /docker-entrypoint.sh # backwards 
compat
+ENTRYPOINT ["tini", "--", "/docker-entrypoint.sh"]
+
+VOLUME /opt/couchdb/data
+
+# 5984: Main CouchDB endpoint
+# 4369: Erlang portmap daemon (epmd)
+# 9100: CouchDB cluster communication port
+EXPOSE 5984 4369 9100
+CMD ["/opt/couchdb/bin/couchdb"]
diff --git a/3.5.1/docker-entrypoint.sh b/3.5.1/docker-entrypoint.sh
new file mode 100755
index 0000000..a8544c7
--- /dev/null
+++ b/3.5.1/docker-entrypoint.sh
@@ -0,0 +1,122 @@
+#!/bin/bash
+# Licensed under the Apache License, Version 2.0 (the "License"); you may not
+# use this file except in compliance with the License. You may obtain a copy of
+# the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+# License for the specific language governing permissions and limitations under
+# the License.
+
+set -e
+
+# first arg is `-something` or `+something`
+if [ "${1#-}" != "$1" ] || [ "${1#+}" != "$1" ]; then
+       set -- /opt/couchdb/bin/couchdb "$@"
+fi
+
+# first arg is the bare word `couchdb`
+if [ "$1" = 'couchdb' ]; then
+       shift
+       set -- /opt/couchdb/bin/couchdb "$@"
+fi
+
+if [ "$1" = '/opt/couchdb/bin/couchdb' ]; then
+       # this is where runtime configuration changes will be written.
+       # we need to explicitly touch it here in case /opt/couchdb/etc has
+       # been mounted as an external volume, in which case it won't exist.
+       # If running as the couchdb user (i.e. container starts as root),
+       # write permissions will be granted below.
+       touch /opt/couchdb/etc/local.d/docker.ini
+
+       # if user is root, assume running under the couchdb user (default)
+       # and ensure it is able to access files and directories that may be 
mounted externally
+       if [ "$(id -u)" = '0' ]; then
+               # Check that we own everything in /opt/couchdb and fix if 
necessary. We also
+               # add the `-f` flag in all the following invocations because 
there may be
+               # cases where some of these ownership and permissions issues 
are non-fatal
+               # (e.g. a config file owned by root with o+r is actually fine), 
and we don't
+               # to be too aggressive about crashing here ...
+               find /opt/couchdb \! \( -user couchdb -group couchdb \) -exec 
chown -f couchdb:couchdb '{}' +
+
+               # Ensure that data files have the correct permissions. We were 
previously
+               # preventing any access to these files outside of 
couchdb:couchdb, but it
+               # turns out that CouchDB itself does not set such restrictive 
permissions
+               # when it creates the files. The approach taken here ensures 
that the
+               # contents of the datadir have the same permissions as they had 
when they
+               # were initially created. This should minimize any startup 
delay.
+               find /opt/couchdb/data -type d ! -perm 0755 -exec chmod -f 0755 
'{}' +
+               find /opt/couchdb/data -type f ! -perm 0644 -exec chmod -f 0644 
'{}' +
+
+               # Do the same thing for configuration files and directories. 
Technically
+               # CouchDB only needs read access to the configuration files as 
all online
+               # changes will be applied to the "docker.ini" file below, but 
we set 644
+               # for the sake of consistency.
+               find /opt/couchdb/etc -type d ! -perm 0755 -exec chmod -f 0755 
'{}' +
+               find /opt/couchdb/etc -type f ! -perm 0644 -exec chmod -f 0644 
'{}' +
+       fi
+
+       if [ ! -z "$NODENAME" ] && ! grep "couchdb@" /opt/couchdb/etc/vm.args; 
then
+               echo "-name couchdb@$NODENAME" >> /opt/couchdb/etc/vm.args
+       fi
+
+       if [ "$COUCHDB_USER" ] && [ "$COUCHDB_PASSWORD" ]; then
+               # Create admin only if not already present
+               if ! grep -Pzoqr "\[admins\]\n$COUCHDB_USER =" 
/opt/couchdb/etc/local.d/*.ini /opt/couchdb/etc/local.ini; then
+                       printf "\n[admins]\n%s = %s\n" "$COUCHDB_USER" 
"$COUCHDB_PASSWORD" >> /opt/couchdb/etc/local.d/docker.ini
+               fi
+       fi
+
+       if [ "$COUCHDB_SECRET" ]; then
+               # Set secret only if not already present
+               if ! grep -Pzoqr "\[chttpd_auth\]\nsecret =" 
/opt/couchdb/etc/local.d/*.ini /opt/couchdb/etc/local.ini; then
+                       printf "\n[chttpd_auth]\nsecret = %s\n" 
"$COUCHDB_SECRET" >> /opt/couchdb/etc/local.d/docker.ini
+               fi
+       fi
+
+       if [ "$COUCHDB_ERLANG_COOKIE" ]; then
+               cookieFile='/opt/couchdb/.erlang.cookie'
+               if [ -e "$cookieFile" ]; then
+                       if [ "$(cat "$cookieFile" 2>/dev/null)" != 
"$COUCHDB_ERLANG_COOKIE" ]; then
+                               echo >&2
+                               echo >&2 "warning: $cookieFile contents do not 
match COUCHDB_ERLANG_COOKIE"
+                               echo >&2
+                       fi
+               else
+                       echo "$COUCHDB_ERLANG_COOKIE" > "$cookieFile"
+               fi
+               chown couchdb:couchdb "$cookieFile"
+               chmod 600 "$cookieFile"
+       fi
+
+       if [ "$(id -u)" = '0' ]; then
+               chown -f couchdb:couchdb /opt/couchdb/etc/local.d/docker.ini || 
true
+       fi
+
+       # if we don't find an [admins] section followed by a non-comment, 
display a warning
+        if ! grep -Pzoqr '\[admins\]\n[^;]\w+' 
/opt/couchdb/etc/default.d/*.ini /opt/couchdb/etc/local.d/*.ini 
/opt/couchdb/etc/local.ini; then
+               # The - option suppresses leading tabs but *not* spaces. :)
+               cat >&2 <<-'EOWARN'
+*************************************************************
+ERROR: CouchDB 3.0+ will no longer run in "Admin Party"
+       mode. You *MUST* specify an admin user and
+       password, either via your own .ini file mapped
+       into the container at /opt/couchdb/etc/local.ini
+       or inside /opt/couchdb/etc/local.d, or with
+       "-e COUCHDB_USER=admin -e COUCHDB_PASSWORD=password"
+       to set it via "docker run".
+*************************************************************
+EOWARN
+               exit 1
+       fi
+
+       if [ "$(id -u)" = '0' ]; then
+               export HOME=$(echo ~couchdb)
+               exec setpriv --reuid=couchdb --regid=couchdb --clear-groups "$@"
+       fi
+fi
+
+exec "$@"
diff --git a/3.5.1/vm.args b/3.5.1/vm.args
new file mode 100644
index 0000000..aeee1e4
--- /dev/null
+++ b/3.5.1/vm.args
@@ -0,0 +1,47 @@
+# Licensed under the Apache License, Version 2.0 (the "License"); you may not
+# use this file except in compliance with the License. You may obtain a copy of
+# the License at
+#
+#   http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+# License for the specific language governing permissions and limitations under
+# the License.
+
+# Ensure that the Erlang VM listens on a known port
+-kernel inet_dist_listen_min 9100
+-kernel inet_dist_listen_max 9100
+
+# Tell kernel and SASL not to log anything
+-kernel error_logger silent
+-sasl sasl_error_logger false
+
+# This will toggle to true in Erlang 25+. However since we don't use global
+# any longer, and have our own auto-connection module, we can keep the
+# existing global behavior to avoid surprises. See
+# https://github.com/erlang/otp/issues/6470#issuecomment-1337421210 for more
+# information about possible increased coordination and messages being sent on
+# disconnections when this setting is enabled.
+#
+-kernel prevent_overlapping_partitions false
+
+# Increase the pool of dirty IO schedulers from 10 to 16
+# Dirty IO schedulers are used for file IO.
++SDio 16
+
+# Increase distribution buffer size from default of 1MB to 32MB. The default is
+# usually a bit low on busy clusters. Has no effect for single-node setups.
+# The unit is in kilobytes.
++zdbbl 32768
+
+# When running on Docker, Kubernetes or an OS using CFS (Completely Fair
+# Scheduler) with CPU quota limits set, disable busy waiting for schedulers to
+# avoid busy waiting consuming too much of Erlang VM's CPU time-slice shares.
++sbwt none
++sbwtdcpu none
++sbwtdio none
+
+# Comment this line out to enable the interactive Erlang shell on startup
++Bd -noinput
diff --git a/README.md b/README.md
index 452368c..2cb5954 100644
--- a/README.md
+++ b/README.md
@@ -9,6 +9,7 @@ There may be more tags available, but these tags should always 
exist:
 - `2`: The very latest CouchDB 2.x single node release (capable of running in 
a cluster)
 
 As of this writing, the latest numbered tags available are:
+- `3.5.1`
 - `3.5.0`
 - `3.4.3`
 - `3.4.2`

Reply via email to